<template>
  <v-container fill-height>
    <v-row justify="center" align="center" no-gutters>
      <v-col cols="12" class="text-center">
        <v-item-group>
          <v-container>
            <v-row justify="center">
              <v-col v-for="(project, i) in projects" :key="i" cols="12" md="3">
                <v-item v-slot:default="{}">
                  <v-card class="mx-auto" max-width="344" outlined>
                    <v-overlay v-if="(i + 1) % 3 === 0" absolute color="red">
                      <v-btn tile color="black">View Completed</v-btn>
                    </v-overlay>
                    <v-list-item two-line>
                      <v-list-item-content>
                        <div class="overline mb-4 font-weight-bold">
                          {{ project.name }}
                        </div>
                        <v-list-item-subtitle>{{
                          project.description
                        }}</v-list-item-subtitle>
                      </v-list-item-content>

                      <v-list-item-avatar tile size="80" color="grey">
                        <img :src="project.image" />
                      </v-list-item-avatar>
                    </v-list-item>

                    <v-card-actions>
                      <v-btn
                        :disabled="(i + 1) % 3 === 0"
                        text
                        @click="openProject(project.uuid)"
                        block
                        >{{ (i + 1) % 3 === 0 ? "" : "Start work" }}</v-btn
                      >
                    </v-card-actions>
                  </v-card>
                </v-item>
              </v-col>
            </v-row>
          </v-container>
        </v-item-group>
      </v-col>
    </v-row>
  </v-container>
</template>

<script lang="ts">
import Vue from "vue";
import { BaseURL, $get } from "../../../api";
import { Request } from "../../../api/types";
import { Project } from "../types";

export default Vue.extend({
  data: () => ({
    active: true,
    projects: [] as Array<Project>
  }),
  created() {
    this.getProjects();
  },
  methods: {
    async getProjects() {
      const request: Request = {
        endpoint: BaseURL + "api/projects/"
      };
      const [err, result] = await $get(this.$store, request);

      if (err) {
        return;
      }

      this.projects = result.data.results;
    },
    openProject(uuid: string) {
      this.$router.push({ name: "project-view", params: { uuid: uuid } });
    }
  }
});
</script>
